<?php 
class Mail {
	var $to;
  	var $from;
  	var $sender;
  	var $subject;
  	var $charset;
  	var $text;
  	var $html;
  	var $attachments = array();
	  
  	function setTo($to) {
    	$this->to = $to;
  	}
  
  	function setFrom($from) {
    	$this->from = $from;
  	}
    
  	function setSender($sender) {
    	$this->sender = $sender;
  	}

  	function setEmail() {
    	$this->email = $email;
  	}
  
  	function setSubject($subject) {
    	$this->subject = $subject;
  	}
  
  	function setCharacterSet($charset) {
    	$this->charset = $charset;
  	}
    
  	function setText($text) {
    	$this->text = $text;
  	}
  
  	function setHtml($html) {
    	$this->html = $html;
  	}
  
  	function setAttachment($attachments) {
    	$this->attachments[] = $attachments;
  	}
  
  	function send() {	
    	if (!$this->to) {
      		exit('Error: To not set');
    	}
	
    	if (!$this->from) {
      		exit('Error: From not set');
    	}
    
    	if (!$this->sender) {
      		exit('Error: Sender not set');
    	}
		
		if (!$this->subject) {
      		exit('Error: Subject not set');
    	}
			
		if ((!$this->text) && (!$this->html)) {
      		exit('Error: Message not set');
    	}

		if (is_array($this->to)) {
      		$to = implode($this->to, ',');
    	} else {
      		$to = $this->to;
    	}
	  	
		if ($this->charset) {
	  		$charset = $this->charset;
		} else { 
	  		$charset = 'utf-8';
		}
	  
		$boundary = '----=_NextPart_' . md5(rand());  
	    
		if (strtoupper(substr(PHP_OS, 0, 3) == 'WIN')) { 
      		$eol = "\r\n"; 
    	} elseif (strtoupper(substr(PHP_OS, 0, 3)=='MAC')) { 
      		$eol = "\r"; 
    	} else { 
      		$eol = "\n"; 
    	} 	
		
		$headers  = 'From: ' . $this->sender . '<' . $this->from . '>' . $eol; 
    	$headers .= 'Reply-To: ' . $this->sender . '<' . $this->from . '>' . $eol;   
    	$headers .= 'X-Mailer: PHP/' . phpversion() . $eol;  
    	$headers .= 'MIME-Version: 1.0' . $eol; 
    	$headers .= 'Content-Type: multipart/mixed; boundary="' . $boundary . '"' . $eol . $eol;  
	
		if (!$this->html) {
	  		$message  = '--' . $boundary . $eol;  
	  		$message .= 'Content-Type: text/plain; charset="' . $charset . '"' . $eol; 
	  		$message .= 'Content-Transfer-Encoding: base64' . $eol . $eol;
      		$message .= chunk_split(base64_encode($this->text));
		} else {
	  		$message  = '--' . $boundary . $eol;
	  		$message .= 'Content-Type: multipart/alternative; boundary="' . $boundary . '_alt"' . $eol . $eol;
	  		$message .= '--' . $boundary . '_alt' . $eol;
	  		$message .= 'Content-Type: text/plain; charset="' . $charset . '"' . $eol; 
	  		$message .= 'Content-Transfer-Encoding: base64' . $eol . $eol;
	  
	  		if ($this->text) {
        		$message .= chunk_split(base64_encode($this->text));
	  		} else {
	    		$message .= chunk_split(base64_encode('This is a HTML email and your email client software does not support HTML email!'));
      		}	
	  
	  		$message .= '--' . $boundary . '_alt' . $eol;
      		$message .= 'Content-Type: text/html; charset="' . $charset . '"' . $eol; 
      		$message .= 'Content-Transfer-Encoding: base64' . $eol . $eol;
	  		$message .= chunk_split(base64_encode($this->html)); 	  
		}
	
    	foreach ($this->attachments as $attachment) {  
      		$filename = basename($attachment);  
      		$handle   = fopen($attachment, "r"); 
      		$content  = '';  
      
	  		while (!feof($handle)) {  
        		$content .= fgets($handle, 1024);  
      		}  
      
	  		$content = chunk_split(base64_encode($content));  
      
	  		fclose($handle);  
	  
      		$message .= '--' . $boundary . $eol;
      		$message .= 'Content-Type: application/octetstream' . $eol;    
      		$message .= 'Content-Transfer-Encoding: base64' . $eol; 
      		$message .= 'Content-Disposition: attachment; filename="' . $filename . $eol; 
      		$message .= 'Content-ID: <' . $filename . '>' . $eol . $eol;
      		$message .= $content;  
    	}  

    	mail($to, $this->subject, $message, $headers);  
	} 
}
?>